//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAEE66603A2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAEE66603A2.cm

//## begin module%3DAEE66603A2.cp preserve=no
//## end module%3DAEE66603A2.cp

//## Module: PlotIcounts%3DAEE66603A2; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotIcounts.cxx

//## begin module%3DAEE66603A2.additionalIncludes preserve=no
//## end module%3DAEE66603A2.additionalIncludes

//## begin module%3DAEE66603A2.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>

//## end module%3DAEE66603A2.includes

// PlotIcounts
#include <XSPlot/Commands/PlotIcounts.h>
//## begin module%3DAEE66603A2.declarations preserve=no
//## end module%3DAEE66603A2.declarations

//## begin module%3DAEE66603A2.additionalDeclarations preserve=yes
//## end module%3DAEE66603A2.additionalDeclarations


// Class PlotIcounts 

PlotIcounts::PlotIcounts()
  //## begin PlotIcounts::PlotIcounts%3DAEE3EB0055_const.hasinit preserve=no
  //## end PlotIcounts::PlotIcounts%3DAEE3EB0055_const.hasinit
  //## begin PlotIcounts::PlotIcounts%3DAEE3EB0055_const.initialization preserve=yes
  : PlotCommand("icounts", new CreateBinnedPlotGroups(false, true))
  //## end PlotIcounts::PlotIcounts%3DAEE3EB0055_const.initialization
{
  //## begin PlotIcounts::PlotIcounts%3DAEE3EB0055_const.body preserve=yes
  isDataRequired(true);
  isActiveModelRequired(false);
  isDivisibleByArea(false);
  addCompLevel(2);
  isBackgroundApplicable(false);
  isPlotGroupDonor(true);
  
  PlotAttributes styles;
  styles.symbolStyle = PlotCommand::standardDataStyle();
  styles.lineStyle = PlotStyle::NONE;
  setStyleMap(PlotStyle::DATA, styles);
  styles.symbolStyle = PlotStyle::BLANK;
  styles.lineStyle = PlotCommand::standardModelStyle();
  styles.lineStep = true;
  styles.lineWidth = 2;
  setStyleMap(PlotStyle::MODEL, styles);
  styles.lineStep = false;
  styles.lineStyle = PlotStyle::DOTTED;
  setStyleMap(PlotStyle::SOURCES, styles);
  //## end PlotIcounts::PlotIcounts%3DAEE3EB0055_const.body
}


PlotIcounts::~PlotIcounts()
{
  //## begin PlotIcounts::~PlotIcounts%3DAEE3EB0055_dest.body preserve=yes
  //## end PlotIcounts::~PlotIcounts%3DAEE3EB0055_dest.body
}



//## Other Operations (implementation)
void PlotIcounts::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotIcounts::manipulate%4B2011A00238.body preserve=yes
   for (size_t iGr=0; iGr<plotGroups.size(); ++iGr)
   {
      PlotGroup* pg = plotGroups[iGr];
      size_t arraySize = pg->n;
      size_t nMods = pg->model.size();
      size_t nSources = pg->sources.size();
      std::vector<Real>& yData = pg->yData.data;
      pg->yData.errors.clear();
      std::vector<Real>& dX = pg->xAxis.errors[0];
      
      yData[0] *= 2*dX[0]; 
      for (size_t i=0; i<nMods; ++i)
         pg->model[i].data[0] *= 2*dX[0];
      if (settings.showAddComponent())
      {
         for (size_t i=0; i<nSources; ++i)
         {
            PlotVectorList::iterator itSl = pg->sources[i].begin();
            PlotVectorList::iterator itSlEnd = pg->sources[i].end();
            while (itSl != itSlEnd)
            {
               itSl->data[0] *= 2*dX[0];
               ++itSl;
            }
         }
      }
       
      for (size_t j=1; j<arraySize; ++j)
      {
         const Real dX2_j = 2*dX[j];
         yData[j] *= dX2_j;
         yData[j] += yData[j-1];
         for (size_t i=0; i<nMods; ++i)
         {
            pg->model[i].data[j] *= dX2_j;
            pg->model[i].data[j] += pg->model[i].data[j-1];
         }
         if (settings.showAddComponent())
         {
            for (size_t i=0; i<nSources; ++i)
            {
               PlotVectorList::iterator itSl = pg->sources[i].begin();
               PlotVectorList::iterator itSlEnd = pg->sources[i].end();
               while (itSl != itSlEnd)
               {
                  itSl->data[j] *= dX2_j;
                  itSl->data[j] += itSl->data[j-1];
                  ++itSl;
               }               
            }
         }
      } // end loop over arraySize
      
      // Now normalize
      const Real totalCounts = yData[arraySize-1];
      if (totalCounts != 0.0)
      {
         for (size_t j=0; j<arraySize; ++j)
         {
            yData[j] /= totalCounts;
            for (size_t i=0; i<nMods; ++i)
               pg->model[i].data[j] /= totalCounts;
            if (settings.showAddComponent())
            {
               for (size_t i=0; i<nSources; ++i)
               {
                  PlotVectorList::iterator itSl = pg->sources[i].begin();
                  PlotVectorList::iterator itSlEnd = pg->sources[i].end();
                  while (itSl != itSlEnd)
                  {
                     itSl->data[j] /= totalCounts;
                     ++itSl;
                  }
               }
            }
         }
      }      
   }
  //## end PlotIcounts::manipulate%4B2011A00238.body
}

void PlotIcounts::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotIcounts::setRanges%4B2011A500D7.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
   
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
                                         
   if (rangeVals.yScaleType == PlotStyle::LOG)
   {
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   }
   else
   {
      // Force yMin range value to 0.
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX + 
                   PlotStyle::YMIN;
      rangeVals.ranges.y1 = 0.0;
   }   
  //## end PlotIcounts::setRanges%4B2011A500D7.body
}

void PlotIcounts::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotIcounts::makeLabels%4B2011A90050.body preserve=yes
   settings.makeXOptionDependentLabel(labels.x);
   labels.y = settings.lookupLabelName("y:icounts");
   labels.title = settings.lookupLabelName("t:icounts");
  //## end PlotIcounts::makeLabels%4B2011A90050.body
}

// Additional Declarations
  //## begin PlotIcounts%3DAEE3EB0055.declarations preserve=yes
  //## end PlotIcounts%3DAEE3EB0055.declarations

//## begin module%3DAEE66603A2.epilog preserve=yes
//## end module%3DAEE66603A2.epilog
